--[[ 

	Martin Karer / Sezz, 2010 [http://sezz.at]
	Simple Action Bar Paging

	This is basicly Dominos for the main actionbar only with bar paging enabled!
	I only copied and pasted code from the dominos lua files without knowing
	what I actually do - QUICK AND DIRTY! Don't bug Jason Greer if something
	isn't working. REALLY - DON'T EVEN THINK OF IT!
	
	Use the full Dominos version if you have any issues with this ripoff:
	http://code.google.com/p/tullamods/wiki/Dominos
	
	PS: NO README, NO HOWTO, NO FAQ, DEAL WITH IT!
	
	Bartender4 "Custom State Header" discussion:
	http://www.wowace.com/addons/bartender4/pages/custom-state-header
	
	Configuration:
		1. find "f.conditions" in the code, uncomment/add the states you need
		2. find your class in the db table, setup show states: [CONDITION]=PAGE
			
	Default settings (unbind your CTRL/ALT keys to use them):
		CTRL: Page 5 ("Bottom Left Bar")
		ALT:  Page 3 ("Right Bar 2")

	------------------------------
	
	Changelog:
	2010-07-04:
		[*] Button anchoring fixes

	2010-06-26:
		[+] First release

--]]

--[[

	Dominos License
	
	------------------------------

	Copyright (c) 2008-2009 Jason Greer
	All rights reserved.

	Redistribution and use in source and binary forms, with or without 
	modification, are permitted provided that the following conditions are met:

		* Redistributions of source code must retain the above copyright notice, 
		  this list of conditions and the following disclaimer.
		* Redistributions in binary form must reproduce the above copyright
		  notice, this list of conditions and the following disclaimer in the 
		  documentation and/or other materials provided with the distribution.
		* Neither the name of the author nor the names of its contributors may 
		  be used to endorse or promote products derived from this software 
		  without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
	LIABLE FORANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
	POSSIBILITY OF SUCH DAMAGE.

--]]

local db = {
	["frames"] = {
		["spacing"] = 6,
		["numButtons"] = 12,
		["pages"] = {
			["HUNTER"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["WARRIOR"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
				["[bonusbar:1]"] = 6,
				["[bonusbar:2]"] = 7,
				["[bonusbar:3]"] = 8,
			},
			["PALADIN"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["MAGE"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["PRIEST"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
				["[bonusbar:1]"] = 6,
			},
			["WARLOCK"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["DEATHKNIGHT"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["DRUID"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
				["[bonusbar:1]"] = 6,
				["[bonusbar:2]"] = 7,
				["[bonusbar:3]"] = 8,
				["[bonusbar:4]"] = 9,
			},
			["SHAMAN"] = {
				["[mod:alt]"] = 3,
				["[mod:ctrl]"] = 5,
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			},
			["ROGUE"] = {
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
				["[bonusbar:1]"] = 6,
				["[form:3]"] = 6,
			},
		}
	},
	["showBindingText"] = true, -- true = blizzard behaviour
	["showMacroText"] = true, -- true = blizzard behaviour
}

-- Locals/Constants
local _G = getfenv(0);
local ceil = math.ceil;
local min = math.min;
local format = string.format;
local MAX_BUTTONS = 120;
local NUM_POSSESS_BAR_BUTTONS = 12;
local NUM_MOUSE_BUTTONS = 31;
local POSSESSED_CONDITIONAL = "[bonusbar:5]";

-- Dominos
local function ToValidID(id)
	return (id - 1) % MAX_BUTTONS + 1;
end

local UpdateActionButtonHotkey = function(self, buttonType)
	local id = self:GetAttribute('bindingid') or self:GetID();
	local actionButtonType = buttonType or self.buttonType;
	if (not actionButtonType) then
		actionButtonType = "ACTIONBUTTON";
	else
		if (actionButtonType == "MULTICASTACTIONBUTTON") then
			id = self.buttonIndex;
		end
	end

	local hotkey = _G[self:GetName().."HotKey"];
	local key = GetBindingKey(actionButtonType..id) or GetBindingKey("CLICK "..self:GetName()..":LeftButton");

	local text = GetBindingText(key, "KEY_", 1);

	if (text ~= "" and db.showBindingText) then
		hotkey:SetText(text);
		hotkey:SetPoint("TOPLEFT", self, "TOPLEFT", -2, -2);
		hotkey:Show();
	else
		hotkey:SetText(RANGE_INDICATOR);
		hotkey:SetPoint("TOPLEFT", self, "TOPLEFT", 1, -2);
		hotkey:Hide();
    end
end

local CreateActionButton = function(id)
	-- ActionButton:Create()
	local b = _G["ActionButton"..id];

	b.buttonType = "ACTIONBUTTON";
	b:SetAttribute("bindingid", b:GetID());
	b:SetID(0);
	b:ClearAllPoints();
	b:SetAttribute("useparent-actionpage", nil);
	b:SetAttribute("useparent-unit", true);
	b:EnableMouseWheel(true);
	b:SetScript("OnEnter", function() ActionButton_SetTooltip(b); end);

	-- ActionButton:New()
	b:SetAttribute("showgrid", 0);
	b:SetAttribute("action--base", id);
	b:SetAttribute("_childupdate-action", [[
		local id = message and self:GetAttribute("action--"..message) or self:GetAttribute("action--base");
		self:SetAttribute("action", id);
	]]);

	-- BindableButton:UpdateHotkey()
	UpdateActionButtonHotkey(b, b.buttonType);

	-- BindableButton:UpdateMacro();
	if (db.showMacroText) then
		_G[b:GetName().."Name"]:Show();
	else
		_G[b:GetName().."Name"]:Hide();
	end

	--hack #1billion, get rid of range indicator text
	local hotkey = _G[b:GetName() .. "HotKey"];
	if hotkey:GetText() == _G["RANGE_INDICATOR"] then
		hotkey:SetText("");
	end
	
	return b;
end

local CreateActionBar = function()
	-- Frame:New()
	-- Frame:Create()
	local f = CreateFrame("Frame", "sActionBar", UIParent);
	f:SetClampedToScreen(true);
	f:SetMovable(false);
	f.id = 1;
	f.buttons = {}

	f.header = CreateFrame("Frame", nil, f, "SecureHandlerStateTemplate");
	f.header:SetAllPoints(f);
	
	-- Frame:LoadSettings()
	f.sets = db.frames;
	UnregisterStateDriver(f.header, "visibility", "show");
	f.header:Show()

	-- Frame:Others()
	f.Layout = function()
		local width, height;
		if (#f.buttons > 0) then
			local b = f.buttons[1];
			local bp;
			local w = b:GetWidth() + f.sets.spacing;
			local h = b:GetHeight();
			
			for i, b in pairs(f.buttons) do
				b:ClearAllPoints();
				if (i == 1) then
					b:SetPoint("BOTTOMLEFT", 0, 0);
				else
					b:SetPoint("LEFT", bp, "RIGHT", f.sets.spacing, 0);
				end

				ActionButton_UpdateHotkeys(b);
				bp = b;
			end
			
			width = w * #f.buttons - f.sets.spacing;
			height = h;
		else
			width = 30;
			height = 30;
		end
		
		f:SetWidth(max(width, 8));
		f:SetHeight(max(height, 8));
	end
	
	-- ActionBar:New()
	-- ActionBar:Create()
	f.defaultOffsets = {
		__index = function(t, i)
			t[i] = {}
			return t[i];
		end
		};

	f.mainbarOffsets = {
		__index = function(t, i)
			local pages = {
				["[bar:2]"] = 1,
				["[bar:3]"] = 2,
				["[bar:4]"] = 3,
				["[bar:5]"] = 4,
				["[bar:6]"] = 5,
			};

			if i == "DRUID" then
--				pages["[bonusbar:1,stealth]"] = 5;
				pages["[bonusbar:1]"] = 6;
				pages["[bonusbar:2]"] = 7;
				pages["[bonusbar:3]"] = 8;
				pages["[bonusbar:4]"] = 9;
			elseif i == "WARRIOR" then
				pages["[bonusbar:1]"] = 6;
				pages["[bonusbar:2]"] = 7;
				pages["[bonusbar:3]"] = 8;
			elseif i == "PRIEST" then
				pages["[bonusbar:1]"] = 6;
			elseif i == "ROGUE" then
				pages["[bonusbar:1]"] = 6;
				pages["[form:3]"] = 6; --shadowdance
--[[
			elseif i == "WARLOCK" then
				pages["[form:2]"] = 6; --demon form, need to watch this to make sure blizzard doesn"t change the page
--]]
			end

			t[i] = pages;
			return pages;
		end
		};

	f.conditions = {
--		"[mod:SELFCAST]",
--		"[mod:alt,mod:ctrl,mod:shift]",
--		"[mod:alt,mod:ctrl]",
--		"[mod:alt,mod:shift]",
--		"[mod:ctrl,mod:shift]",
		"[mod:alt]",
		"[mod:ctrl]",
--		"[mod:shift]",
		POSSESSED_CONDITIONAL,
		"[bar:2]",
		"[bar:3]",
		"[bar:4]",
		"[bar:5]",
		"[bar:6]",
		"[form:2]",
		"[form:3]",
		"[bonusbar:1,stealth]", --prowl
		"[bonusbar:1]",
		"[bonusbar:2]",
		"[bonusbar:3]",
		"[bonusbar:4]",
--		"[help]",
--		"[harm]",
--		"[noexists]",
		};

	f.class = select(2, UnitClass("player"));
	f.sets.pages = setmetatable(f.sets.pages, f.id == 1 and f.mainbarOffsets or f.defaultOffsets);
	f.pages = f.sets.pages[f.class];
	f.baseID = 0;

	-- LoadStateController()
	f.header:SetAttribute('_onstate-page', [[ control:ChildUpdate('action', newstate) ]]);
	
	-- LoadButtons()
	f.UpdateActions = function()
		for state,condition in ipairs(f.conditions) do
			local page = f.pages[condition];
			for i,b in pairs(f.buttons) do
				local page = f.pages[condition];
				local id = page and ToValidID(i + (f.id + page - 1) * 12) or nil;
				b:SetAttribute("action--S"..state, id);
				
				if (state==16) then
					print(id);
				end
			end
		end

		for i = 1, min(#f.buttons, NUM_POSSESS_BAR_BUTTONS) do
			f.buttons[i]:SetAttribute("action--possess", MAX_BUTTONS + i);
		end
		for i = NUM_POSSESS_BAR_BUTTONS + 1, #f.buttons do
			f.buttons[i]:SetAttribute("action--possess", nil);
		end
	end
	
	for i = 1, f.sets.numButtons do
		local b = CreateActionButton(i);
		if b then
			b:SetParent(f.header);
			f.buttons[i] = b;
		else
			break;
		end
	end

	f:UpdateActions();
	
	-- Hook Blizzard's Action Button Hotkey Update Function
	hooksecurefunc("ActionButton_UpdateHotkeys", UpdateActionButtonHotkey);

	-- UpdateStateDriver()
	f.RefreshActions = function()
		local state = f.header:GetAttribute("state-page");
		if state then
			f.header:Execute(format([[ control:ChildUpdate("action", "%s") ]], state));
		else
			f.header:Execute([[ control:ChildUpdate("action", nil) ]]);
		end
	end

	f.UpdateStateDriver = function()
		UnregisterStateDriver(f.header, 'page', 0);

		local header = "";
		for state, condition in ipairs(f.conditions) do
			--possess bar: special case
			if (condition == POSSESSED_CONDITIONAL) then
				header = header..condition.."possess;";
			elseif (f.pages[condition]) then
				header = header..condition.."S"..state..";";
			end
		end

		if (header ~= "") then
			RegisterStateDriver(f.header, "page", header..0);
		end

		f:UpdateActions();
		f:RefreshActions()
	end
	
	f:UpdateStateDriver();

	-- Layout()
	f.Layout();
	
	-- UpdateGrid()/HideGrid()
	for _, b in pairs(f.buttons) do
		b:SetAttribute("showgrid", 0);
	end

	return f;
end

-- Create action bar frame
local sActionBar = CreateActionBar();

-- Disable BonusActionBar
ShowBonusActionBar = Multibar_EmptyFunc;
BonusActionBarFrame:UnregisterAllEvents();
BonusActionBarFrame:Hide();

-- Replace Blizzard's default action bar
sActionBar:SetParent(MainMenuBarArtFrame);
sActionBar:SetPoint("BOTTOMLEFT", MainMenuBar, 8, 4);
